aim4.vehicle

## Interface AutoVehicleDriverView

- All Superinterfaces:
    VehicleDriverView
  All Known Subinterfaces:
    AutoVehicleSimView, ProxyVehicleSimView
  All Known Implementing Classes:
    BasicAutoVehicle, ProxyVehicle

      public interface AutoVehicleDriverView
      extends VehicleDriverView

  The interface of an autonomous vehicle from the viewpoint of a driver.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `AutoVehicleDriverView.LRFMode` Potential operating modes for a vehicle's laser range finder.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getBitsReceived()` Get the number of bits this Vehicle has received.
    `int` | `getBitsTransmitted()` Get the number of bits this Vehicle has transmitted.
    `AutoDriver` | `getDriver()` Getter method for the Driver controlling this Vehicle.
    `DoubleGauge` | `getFrontVehicleDistanceSensor()` Get this Vehicle's gauge of sensors about the distance, in meters, between p1 and p2, both of them are points on the target lane, where p1 is the point projected from the center of the front of the vehicle, and p2 is the nearest point of another vehicle in the front of the vehicle to p1 on the target lane.
    `DoubleGauge` | `getFrontVehicleSpeedSensor()` Get this Vehicle's gauge of sensors about the speed, in meters per second, of the vehicle in front of the vehicle on the target lane.
    `DoubleGauge` | `getIntervalometer()` Get this Vehicle's interval-to-vehicle-in-front gauge.
    `V2IMessage` | `getLastV2IMessage()` Get the last V2I message
    `DoubleGauge` | `getLRFDistance()` Get this Vehicle's laser range finder distance gauge.
    `AutoVehicleDriverView.LRFMode` | `getLRFMode()` Get the Vehicle's laser range finder operating mode.
    `DoubleGauge` | `getRearVehicleDistanceSensor()` Get this Vehicle's gauge of sensors about the distance, in meters, between p1 and p2, both of them are points on the target lane, where p1 is the point projected from the center of the front of the vehicle, and p2 is the nearest point of another vehicle behind the vehicle to p1 on the target lane.
    `DoubleGauge` | `getRearVehicleSpeedSensor()` Get this Vehicle's gauge of sensors about the speed, in meters per second, of the vehicle behind the vehicle on the target lane.
    `Lane` | `getTargetLaneForVehicleTracking()` Return the target lane for vehicle tracking.
    `double` | `getTransmissionPower()` Get the Vehicle's transmission power.
    `boolean` | `isLRFSensing()` Get whether or not the laser range finder is sensing anything.
    `boolean` | `isVehicleTracking()` Get whether or not the vehicle tracking sensors are sensing anything.
    `List<I2VMessage>` | `pollAllMessagesFromI2VInbox()` Get the list of all messages currently in the queue of I2V messages waiting to be read by this Vehicle.
    `void` | `receive(I2VMessage msg)` Adds a message to the incoming queue of messages received from IntersectionManagers.
    `void` | `send(V2IMessage msg)` Adds a message to the outgoing queue of messages to be delivered to an IntersectionManager.
    `void` | `setTargetLaneForVehicleTracking(Lane lane)` Set the target lane for vehicle tracking.
    `void` | `setVehicleTracking(boolean sensing)` Set whether or not the vehicle tracking sensors are sensing anything.

    - ### Methods inherited from interface aim4.vehicle.VehicleDriverView

      `coast, gaugeHeading, gaugePointAtMiddleFront, gaugePointAtRear, gaugePointBetweenFrontWheels, gaugePosition, gaugeRearLeftCornerPoint, gaugeRearRightCornerPoint, gaugeShape, gaugeTime, gaugeVelocity, getAccelSchedule, getSpec, getVIN, printState, removeAccelSchedule, setAccelSchedule, setAccelWithMaxTargetVelocity, setTargetVelocityWithMaxAccel, slowToStop, turnTowardPoint`

- - ### Method Detail

    - #### getDriver

          AutoDriver getDriver()

      Getter method for the Driver controlling this Vehicle.
      Specified by:
        `getDriver` in interface `VehicleDriverView`
      Returns:
        the Driver controlling this Vehicle, or `null` if none exists.

    - #### getIntervalometer

          DoubleGauge getIntervalometer()

      Get this Vehicle's interval-to-vehicle-in-front gauge. This should only be followed by a call to `read`, except in the actual physical simulator which is allowed to set these values.
      Returns:
        the Vehicle's interval-to-vehicle-in-front gauge

    - #### getLRFMode

          AutoVehicleDriverView.LRFMode getLRFMode()

      Get the Vehicle's laser range finder operating mode.
      Returns:
        the current operating mode of the laser range finder
      See Also:
        `AutoVehicleDriverView.LRFMode`

    - #### isLRFSensing

          boolean isLRFSensing()

      Get whether or not the laser range finder is sensing anything.
      Returns:
        whether or not the laser range finder is sensing anything

    - #### getLRFDistance

          DoubleGauge getLRFDistance()

      Get this Vehicle's laser range finder distance gauge. This should only be followed by a call to `read`, except in the actual physical simulator which is allowed to set these values.
      Returns:
        the Vehicle's laser range finder angle gauge

    - #### isVehicleTracking

          boolean isVehicleTracking()

      Get whether or not the vehicle tracking sensors are sensing anything.
      Returns:
        whether or not the vehicle tracking sensors are sensing anything

    - #### setVehicleTracking

          void setVehicleTracking(boolean sensing)

      Set whether or not the vehicle tracking sensors are sensing anything.
      Parameters:
        `sensing` - whether or not the vehicle tracking sensors are sensing anything

    - #### getTargetLaneForVehicleTracking

          Lane getTargetLaneForVehicleTracking()

      Return the target lane for vehicle tracking.
      Returns:
        the target lane for vehicle tracking

    - #### setTargetLaneForVehicleTracking

          void setTargetLaneForVehicleTracking(Lane lane)

      Set the target lane for vehicle tracking.
      Parameters:
        `lane` - the target lane for vehicle tracking

    - #### getFrontVehicleDistanceSensor

          DoubleGauge getFrontVehicleDistanceSensor()

      Get this Vehicle's gauge of sensors about the distance, in meters, between p1 and p2, both of them are points on the target lane, where p1 is the point projected from the center of the front of the vehicle, and p2 is the nearest point of another vehicle in the front of the vehicle to p1 on the target lane. If there is no vehicle in the front on the target lane, the value should be Double.MAX_VALUE.
      Returns:
        the distance of the vehicle in the front on the target lane.

    - #### getRearVehicleDistanceSensor

          DoubleGauge getRearVehicleDistanceSensor()

      Get this Vehicle's gauge of sensors about the distance, in meters, between p1 and p2, both of them are points on the target lane, where p1 is the point projected from the center of the front of the vehicle, and p2 is the nearest point of another vehicle behind the vehicle to p1 on the target lane. If there is no vehicle behind on the target lane, the value should be Double.MAX_VALUE.
      Returns:
        the distance of the vehicle behind on the target lane.

    - #### getFrontVehicleSpeedSensor

          DoubleGauge getFrontVehicleSpeedSensor()

      Get this Vehicle's gauge of sensors about the speed, in meters per second, of the vehicle in front of the vehicle on the target lane. If there is no vehicle in the front on the target lane, the value should be Double.MAX_VALUE.
      Returns:
        the speed of the vehicle in the front on the target lane.

    - #### getRearVehicleSpeedSensor

          DoubleGauge getRearVehicleSpeedSensor()

      Get this Vehicle's gauge of sensors about the speed, in meters per second, of the vehicle behind the vehicle on the target lane. If there is no vehicle behind on the target lane, the value should be Double.MAX_VALUE.
      Returns:
        the speed of the vehicle behind on the target lane.

    - #### getTransmissionPower

          double getTransmissionPower()

      Get the Vehicle's transmission power.
      Returns:
        the Vehicle's transmission power, in meters

    - #### getBitsReceived

          int getBitsReceived()

      Get the number of bits this Vehicle has received.
      Returns:
        the number of bits this Vehicle has received

    - #### getBitsTransmitted

          int getBitsTransmitted()

      Get the number of bits this Vehicle has transmitted.
      Returns:
        the number of bits this Vehicle has transmitted

    - #### pollAllMessagesFromI2VInbox

          List<I2VMessage> pollAllMessagesFromI2VInbox()

      Get the list of all messages currently in the queue of I2V messages waiting to be read by this Vehicle.
      Returns:
        the list of all messages currently in the queue of I2V messages.

    - #### send

          void send(V2IMessage msg)

      Adds a message to the outgoing queue of messages to be delivered to an IntersectionManager.
      Parameters:
        `msg` - the message to send to an IntersectionManager

    - #### receive

          void receive(I2VMessage msg)

      Adds a message to the incoming queue of messages received from IntersectionManagers.
      Parameters:
        `msg` - the message to send to another Vehicle

    - #### getLastV2IMessage

          V2IMessage getLastV2IMessage()

      Get the last V2I message
      Returns:
        the last V2I message

Copyright © 2013. All rights reserved.